<?php
namespace PME\Controllers\Parametrizacao;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class PercentualAdesaoPratoController extends \PME\Services\TeknisaCrud {
    protected $crudService;
	protected $parameterBag;
	protected $connection;
	protected $environment;

    public function __construct($crudService, $parameterBag, $connection, $environment) {
        parent::__construct($crudService, $parameterBag);
        $this->connection = $connection;
        $this->environment = $environment;
	}
	
	public function save(DTO\Request $request, DTO\Response $response) {
	    try {
	        $params = $request->getParameters();
	        $nrorg = $this->environment->getNrOrg();
	        
	        $queryUpdate = "UPDATE PERACEITPRATO SET VRPERACEIT = :VRPERACEIT WHERE CDFILCENTPME = :CDFILCENTPME AND CDFILIAL = :CDFILIAL AND CDPRATO = :CDPRATO AND NRORG = :NRORG AND CDTIPOCARD = :CDTIPOCARD";
	        $queryInsert = "INSERT INTO PERACEITPRATO (NRPERACEITPRATO, CDFILCENTPME, CDFILIAL, VRPERACEIT, NRORG, CDTIPOCARD, CDPRATO, CDFILAUXPRAT) VALUES (:NRPERACEITPRATO, :CDFILCENTPME, :CDFILIAL, :VRPERACEIT, :NRORG, :CDTIPOCARD, :CDPRATO, :CDFILAUXPRAT)";
	        
	        $this->connection->beginTransaction();
	        $primaryKey = $this->getMaxNrPerAceitPrato()[0]['PRIMARY'];
	        
	        foreach ($params['editedRows'] as $data) {
	        	$params = array(
                    "CDFILCENTPME" => $data['CDFILCENTPME'],
                    "CDFILIAL"     => $data['CDFILIAL'],
                    "CDTIPOCARD"   => $data['CDTIPOCARD'],
                    "CDPRATO"      => $data['CDPRATO'],
                    "VRPERACEIT"   => empty($data['VRPERACEIT']) ? 0 : $data['VRPERACEIT'],
                    "NRORG"        => $nrorg
                );
                
	        	if(in_array('isNew', $data) and $data['__is_new'] === true) {
	        	  $primaryKey = $primaryKey + 1;	
	        	  $params['CDFILAUXPRAT'] = $data['CDFILAUXPRAT'];
	        	  $params['NRPERACEITPRATO'] = $primaryKey;
	        	  $stmt = $this->connection->prepare($queryInsert);
	        	}else{
	        	  $stmt = $this->connection->prepare($queryUpdate);
	        	}
	        	
	        	$stmt->execute($params);
	        };
	        $this->connection->commit();
	        $response->addDataSet(new DataSet("save", array(true)));
	    } catch (\Exception $e) {
	    	$this->connection->rollback();
			$response->setError(new Error($e->getMessage(), 500));
		}
	}
	
	private function getMaxNrPerAceitPrato() {
		$query = "SELECT MAX(NRPERACEITPRATO) AS PRIMARY FROM PERACEITPRATO";
		$stmt = $this->connection->prepare($query);
		$stmt->execute();
		
        return $stmt->fetchAll();
	}
}