<?php
namespace PME\Modules\Planejamento\Parametrizacao;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class NutrientesPorProduto extends \Zeedhi\Framework\Controller\Report {

    protected $birtStrategy;
    protected $utilities;

    public function __construct(ReportService $reportService, $birtStrategy, $utilities) {
      $this->birtStrategy  = $birtStrategy;
      $this->utilities   = $utilities;

      parent::__construct($reportService);
    }

	protected $reportMapping = array (
        'GER04000' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "TAMACNIVEL"  => "P_NIVEL",
              "PRODINICIAL" => "P_PRODINI",
              "PRODFINAL"   => "P_PRODFIM",
              "NUTRIENTES"  => "P_CDNUTRIENTE",
              "ORDENA"      => "P_ORDENA",
              "CDNVPRODUTO" => "P_CDNVPRODMASK",
              "PRODUCTMASK" => "P_PRODUCTMASK",
              "NRORG"       => "P_NRORG",
              "ORDEM"       => "P_CRESDECRES"
            )
        ),
        'GER04001' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
              "TAMACNIVEL"  => "P_NIVEL",
              "PRODINICIAL" => "P_PRODINI",
              "PRODFINAL"   => "P_PRODFIM",
              "NUTRIENTES"  => "P_CDNUTRIENTE",
              "ORDENA"      => "P_ORDENA",
              "CDNVPRODUTO" => "P_CDNVPRODMASK",
              "PRODUCTMASK" => "P_PRODUCTMASK",
              "NRORG"       => "P_NRORG",
              "ORDEM"       => "P_CRESDECRES"
            )
        )
    );
    
    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        $nrorg = $this->utilities->getNrOrg();
        
        if (empty($row['NUTRIENTES'])) $row['NUTRIENTES'] = 'T';
        else {
            $nutrientes = [];
            foreach ($row['NUTRIENTES'] as $pos) {
                $concatNutri = $pos['CDNUTRIENTE'];
                array_push($nutrientes, $concatNutri);
            }
            $row['NUTRIENTES'] = '_' . implode("_", $nutrientes) . '_';
        }
        
        $cdprodIni = $row['PRODINICIAL']['CDARVPROD'] ? $row['PRODINICIAL']['CDARVPROD'] : 0;
        if(empty($row['PRODFINAL']['CDARVPROD'])) $cdprodFin = 'zzzzzzzzzzz';
        else $cdprodFin = str_pad($row['PRODFINAL']['CDARVPROD'], 10, 'z');
        
        $row['PRODINICIAL'] = $cdprodIni;
        $row['PRODFINAL'] = $cdprodFin;
        $row['NRORG'] = $nrorg;
      
        $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
        $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }
}